# 3. 课题研发内容与初步计划

## 3.1 课题研发内容

1. 一份ebpf技术的入门教程与lab
2. 实现一个接近工业界的工具
3. 输出一系列开发文档（合订）

* 开发工具的使用教程——环境搭建；工具说明书；
* 开发工具的设计文档——设计架构、各模块详细设计、数据流程；
* 开发工具的开发文档——各模块的作用、函数的注释；
* 测试文档——测试环境的搭建教程；设计多种容器环境，进行测试；
* 过程文档——时间段、分工、迭代版次&版本变化；

## 3.2 课题研发模块

### 3.2.1 ebpf入门教程与Lab设计

1. ebpf介绍
2. 介绍bcc、libbpf与demo
3. 基于libbpf-bootstrap的系统跟踪、监控
4. 容器与进程
5. 文件系统
6. Seccomp权限准入机制
7. ...

### 3.2.2 课题工具研发设计

**功能设计**

1. 进程信息监控
2. 系统调用跟踪
3. 进程间通信监控
4. Tcp流量端监控
5. 进程-容器映射
6. ...

**研发文档**

1. 调研文档
2. 系统设计文档
3. 模块设计文档
4. 开发计划文档
5. 版本更新文档
6. 开发日志文档
7. issue文档
8. 测试场景设计文档
9. 测试报告
10. 性能分析报告（可选）

## 3.3 研发计划

阶段一：学习ebpf相关技术栈（3.10~4.2）

* [X] 入门ebpf技术栈
* [X] 调研、学习 `bcc`
* [X] 调研、学习 `libbpf` 、`libbpf-bootstrap`
* [X] 调研、学习 `seccomp`
* [X] 输出调研文档

阶段二：项目设计（4.3~4.10）

* [X] 与mentor讨论项目需求、并设计功能模块
* [ ] 输出系统设计文档
* [ ] 输出模块设计文档

阶段三：开发迭代（4.10~6.1）

* [X] 实现进程信息监控（pid、ppid等）
* [X] 实现系统调用信息监控
* [X] 实现进程间通信监控
* [X] 实现tcp（ipv4、ipv6）通信监控
* [X] 实现监控信息存储功能（csv或json格式）
* [X] 完成了系统的原型验证功能
* [ ] 基于上述功能，实现命令行调用，完成版本v0.1
* [ ] 输出开发v0.1日志文档
* [ ] 实现进程id与容器id映射，进程信息过滤
* [ ] 添加“seccomp”功能
* [ ] 基于上述新增功能，迭代版本v0.2
* [ ] 输出开发v0.2日志文档
* [ ] 添加可视化模块
* [ ] 基于上述新增功能，迭代版本v0.3
* [ ] 输出开发v0.3日志文档
* [ ] 后续更新迭代

阶段四：开发测试（6.2~6.16）

* [ ] 设计测试场景（分别针对基础功能、权限控制、安全逃逸场景）
* [ ] 搭建测试环境
* [ ] 测试-开发
* [ ] 输出测试文档

阶段五：项目文档完善（6.17~7.1）

* [ ] 完善开发文档
* [ ] 完善教程文档
* [ ] 完善labs
